﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ThinkGeo.MapSuite.Routing;
using ThinkGeo.MapSuite.Core;
using System.Windows.Forms;

namespace EjemplosMS.CODE
{
    class BuildRouteIndex
    {
        private const string rootPath = @"..\..\shape\";
        private FeatureSource featureSource;

        public BuildRouteIndex()
        {
            RtgRoutingSource.BuildingRoutingData += new EventHandler<BuildingRoutingDataRtgRoutingSourceEventArgs>(RtgRoutingSource_BuildingRoadData);
        }

        private void RtgRoutingSource_BuildingRoadData(object sender, BuildingRoutingDataRtgRoutingSourceEventArgs e)
        {

            OneWayRoad(e);
        }
        private FeatureSource GetFeatureSource()
        {
            FeatureSource featureSource = null;
            featureSource = new ShapeFileFeatureSource(rootPath + "med_laureles_polyline.shp");              
            return featureSource;
        }
        public void build()
        {

           
                featureSource = GetFeatureSource();
                RtgRoutingSource.GenerateRoutingData(rootPath + "med_laureles_polyline", featureSource, BuildRoutingDataMode.Rebuild, "");
                MessageBox.Show("Finish building routing data!");
            
        }

        private void OneWayRoad(BuildingRoutingDataRtgRoutingSourceEventArgs e)
        {
            featureSource.Open();
            string featureId = e.LineShape.Id.Split(new string[] { "::" }, StringSplitOptions.RemoveEmptyEntries)[0];
            Feature feature = featureSource.GetFeatureById(featureId, new string[] { "ONE_WAY" });

            // One-Way	1=yes, 0=no
            string oneWay = feature.ColumnValues["ONE_WAY"];
            // Indicator 1=opposite to the routeSegment direction		
            //string indicator = feature.ColumnValues["Indicator"];
            
            if (oneWay == "1") return;
            if (oneWay == "2") e.RouteSegment.StartPointAdjacentIds.Clear();
            else if (oneWay == "3") e.RouteSegment.EndPointAdjacentIds.Clear();
            else
            {
                e.RouteSegment.StartPointAdjacentIds.Clear();
                e.RouteSegment.EndPointAdjacentIds.Clear();
            }
            //if (oneWay == "1")
            //{
            //    if (indicator == "0")
            //    {
            //        e.RouteSegment.StartPointAdjacentIds.Clear();
            //    }
            //    else
            //    {
            //        e.RouteSegment.EndPointAdjacentIds.Clear();
            //    }
            //}
        }
    }
}
