﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using EjemplosMS.CODE;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;
using ThinkGeo.MapSuite.Routing;

namespace EjemplosMS
{
    public partial class Form1 : Form
    {
        private FeatureSource featureSource;
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            BuildRouteIndex ri = new BuildRouteIndex();
            ri.build();

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            featureSource = new ShapeFileFeatureSource(@"..\..\shape\med_laureles_polyline.shp");
            //austinstreetsLayer.Open();
            RenderMap();
        }

        private void RenderMap()
        {
            winformsMap1.MapUnit = GeographyUnit.DecimalDegree;
            winformsMap1.BackgroundOverlay.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#e6e5d1"));
            winformsMap1.CurrentExtent = new RectangleShape(-75.604106, 6.254515, -75.583619, 6.235973);

            winformsMap1.BackgroundOverlay.BackgroundBrush = new GeoSolidBrush(GeoColor.GeographicColors.ShallowOcean);

            //ShapeFileFeatureLayer worldLayer2 = new ShapeFileFeatureLayer(@"C:\Documents and Settings\mario_aldana\Escritorio\Network Med\MED_SHAPE\Data\Col_Limite_region.shp");
            //worldLayer2.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Country1;            
            //worldLayer2.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            //LayerOverlay staticOverlay2 = new LayerOverlay();
            //staticOverlay2.Layers.Add("WorldLayer2", worldLayer2);


            ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(@"..\..\shape\med_laureles_polyline.shp");
            worldLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.LocalRoad2;
            worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            LayerOverlay staticOverlay = new LayerOverlay();
            staticOverlay.Layers.Add("WorldLayer", worldLayer);
            //winformsMap1.Overlays.Add(staticOverlay2);
            winformsMap1.Overlays.Add(staticOverlay);


            /////////////////////////
            ShapeFileFeatureLayer austinstreetsLayer = new ShapeFileFeatureLayer(@"..\..\shape\med_laureles_polyline.shp");
            //austinstreetsLayer.Open();

            RoutingLayer routingLayer = new RoutingLayer();
            austinstreetsLayer.Open();
            routingLayer.StartPoint = austinstreetsLayer.FeatureSource.GetFeatureById("86", ReturningColumnsType.NoColumns).GetShape().GetCenterPoint();
            routingLayer.EndPoint = austinstreetsLayer.FeatureSource.GetFeatureById("150", ReturningColumnsType.NoColumns).GetShape().GetCenterPoint();
            austinstreetsLayer.Close();
            LayerOverlay routingOverlay = new LayerOverlay();
            routingOverlay.Layers.Add("RoutingLayer", routingLayer);
            winformsMap1.Overlays.Add("RoutingOverlay", routingOverlay);
            ShowTheShortestPath(routingLayer);

            InMemoryFeatureLayer routingExtentLayer = new InMemoryFeatureLayer();
            routingExtentLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = new AreaStyle(new GeoPen(GeoColor.SimpleColors.Green));
            routingExtentLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            routingExtentLayer.InternalFeatures.Add(new Feature(new RectangleShape(-75.604106, 6.254515, -75.583619, 6.235973)));
            routingOverlay.Layers.Add("RoutingExtentLayer", routingExtentLayer);



            winformsMap1.Refresh();
        }
        private void ShowTheShortestPath(RoutingLayer routingLayer)
        {
            try
            {
                RoutingSource routingSource = new RtgRoutingSource(@"..\..\shape\med_laureles_polyline.rtg");
                RoutingEngine routingEngine = new RoutingEngine(routingSource, featureSource);
                RoutingResult routingResult = routingEngine.GetRoute("150", "86");

                routingLayer.Routes.Clear();
                routingLayer.Routes.Add(routingResult.Route);
            }
            catch (Exception ex) {
                MessageBox.Show(ex.ToString());
            }
        }
    }
}
